<h2>3 - Introducing WebBox-es</h2>

<p>Explains what are WebBox-es and their differences with templates.
The PHP code of the WebBox-es declares template <em>{{#variables}}</em>
in the <em>onRender()</em> function, by using <em>WebApp::addVar()</em>.
Gives some tips about good programming practices with WebBox-es. 
Introduces as well the files <em>init.php</em>, <em>global.php</em>, 
<em>before_page.php</em> and <em>after_page.php</em>.</p>

<span class="button">
  <a href="{{UP_URL}}app3/" target= "_blank">Test</a>
</span>
<span class="button">
  <a href="{{UP_URL}}app3/browse.php" target="_blank">Browse</a>
</span>
<!--#
<span class="button">
  <a href="{{HOME_URL}}get/app3.tar.gz">Download</a>
</span>
#-->
<br />

<hr />

<h3><a name="toc">Table of Contents</a></h3>

<ul>
  <li>
    <a href="#webboxes">WebBox-es</a>

    <ol>
      <li><a href="#phpcode">The PHP code of a WebBox</a></li>

      <li><a href="#onrender">The function <em>onRender()</em></a></li>

      <li><a href="#files">Files related to a WebBox</a></li>

      <li><a href="#differences">Differences with templates</a></li>
    </ol>
  </li>

  <li><a href="#tips">Tips about using WebBox-es</a></li>

  <li><a href="#study">Study the sample application</a></li>

  <li>
    <a href="#exercises">Exercises</a>

    <ol>
      <li><a href="#exercise_1">Use webbox <em>menu</em> in application 
      <em>app2</em></a></li>

      <li><a href="#exercise_2">Use webbox <em>tip</em> in application 
      <em>app2</em></a></li>

      <li><a href="#exercise_3">Enable counting</a></li>

      <li><a href="#exercise_4">Test <em>before_page.php</em> and 
      <em>after_page.php</em></a></li>

      <li><a href="#exercise_5">Modify the <em>tip</em> webbox</a></li>
    </ol>
  </li>
</ul>
<hr />

<a name="webboxes"></a>

<h3>WebBox-es</h3>

<p>A WebBox is a template which has also some <em>PHP</em> code associated 
with it. It is a self-contained and independent template which can be easily 
included in other pages or in other applications. In fact, it may also have
some <em>JavaScript</em> code, <em>CSS</em> stylesheets, <em>SQL</em>
queries etc., associated with it.</p>

<p>It is denoted by the tag <strong>&amp;lt;WebBox&amp;gt;</strong> and it has an 
<strong>ID</strong> attribute:</p>
<pre>
  &amp;lt;WebBox id="box_id"&amp;gt;
    &amp;lt;!-- content of WebBox --&amp;gt;
  &amp;lt;/WebBox&amp;gt;
</pre>
<p>The identifier must be different for each WebBox used in the 
application.</p>

<a name="phpcode"></a>

<h4>1 - The PHP code of the WebBox-es</h4>

<p>The <em>PHP</em> code (as well as <em>JS</em> code, <em>CSS</em>
styles etc.)  are associated to the WebBox by means of
<strong>box_id</strong>, the identifier of the WebBox.  When the
framework parses a <strong>&amp;lt;WebBox&amp;gt;</strong> tag, it looks for a
file named <strong>box_id.php</strong> in the same folder where the
WebBox template is. If it finds such a file, it includes it.</p>

<p>The <strong>box_id.php</strong> file must contain the definition 
of a <em>PHP</em> class that extends the class <strong>WebObject</strong>,
like this:</p>
<pre>
  &amp;lt;?php
  class <strong>box_id</strong> extends <strong>WebObject</strong>
  {
    .
    .
    .
  }
  ?&amp;gt;
</pre>

<p>See this example:
<a href="javascript:codeReview('{{SAPPS_PATH}}app3/templates/menu/menu.html','1')">
<em>templates/menu/menu.html</em></a>,
<a href="javascript:codeReview('{{SAPPS_PATH}}app3/templates/menu/menu.php','4')">
<em>templates/menu/menu.php</em></a>.
</p>

<p>The class <strong>WebObject</strong> is defined by the framework.
Among other things, it also contains the member functions
<strong>WebObject::init()</strong>,
<strong>WebObject::onParse()</strong> and
<strong>WebObject::onRender()</strong>. We will discuss in the next
tutorial the first two functions, and will deal here only with the
last one.</p>

<a name="onrender"></a>

<h4>2 - The function <em>onRender()</em></h4>

<p>The function <strong>onRender()</strong> of the class
<em>WebObject</em> is called by the framework at the time of the
<em>HTML</em> page construction (the page that is sent to the
browser), just before the template of the WebBox is outputed
(rendered).  Actually <strong>WebObject::onRender()</strong> is an
abstract (empty) function, and the framework expects the class
<strong>box_id</strong> to override it, in order to do something
useful for the WebBox.</p>

<p>What is usually done in <strong>box_id::onRender()</strong> is
assigning values to the variables used in the template of the WebBox
<em>box_id</em>, so that the template is rendered properly. 
These values are assigned by the function 
<strong>WebApp::addVar("var_name", "var_value")</strong>. 
E.g. see how it is done in the WebBox <em>tip</em>: 
<a href="javascript:codeReview('{{SAPPS_PATH}}app3/templates/tip/tip.html','5')">
<em>templates/tip/tip.html</em></a>,  
<a href="javascript:codeReview('{{SAPPS_PATH}}app3/templates/tip/tip.php','12,15')">
<em>templates/tip/tip.php</em></a>.  
The framework replaces the variables {{#rand}} and {{#tip_text}} by the 
values assigned in onRender() and generates <em>HTML</em> code. </p>

<a name="files"></a>

<h4>3 - Files related to a WebBox</h4>

<p>Besides the file that contains the template of the WebBox and the
<strong>box_id.php</strong> that contains its <em>PHP</em> class,
there may be other files as well that belong to the WebBox. These are:
<strong>box_id.js</strong> that contains the JavaScript code of the
WebBox, <strong>box_id.css</strong> that contains the stylesheet of
the WebBox, etc. (we will see the others later).  If the framework
finds such files, it automatically integrates them in the generated
<em>HTML</em> page. For example, it includes
<strong>box_id.js</strong> and <strong>box_id.css</strong> in the
<em>&amp;lt;head&amp;gt;</em> of the page. As an example, 
<a href="{{SAPPS_URL}}app3/browse.php?templates/menu/" target="_blank">
see the files of the WebBox <em>menu</em></a>.</p>

<p>Of these files, the template is the most important. There can be a
WebBox without <em>JS</em> code or without <em>PHP</em> code, but
there cannot be a WebBox without <em>TPL</em>(template) code.</p>

<a name="differences"></a>

<h4>4 - Differences with templates</h4>

<p>A WebBox is defined inside a template file and the <em>TPL</em>
code of the WebBox is inside the <em>&amp;lt;WebBox&amp;gt;</em> tag (is the
content of the <em>&amp;lt;WebBox&amp;gt;</em> element). However a WebBox is
different from a template because it can also have its own
<em>PHP</em> code. Another difference is that a template must include
explicitly the <em>JS</em> code and the <em>CSS</em> code (if it has
its own), 
<a href="javascript:codeReview('{{SAPPS_PATH}}app2/templates/page3/tmpl.html','1')">
<em>see this example</em></a>, however, for a WebBox the framework
handles them automatically, by including them at the
<em>&amp;lt;head&amp;gt;</em> of the page</p>

<span class="button"><a href="#toc">TOC</a></span>
<hr />

<a name="tips"></a>

<h3>Tips about using WebBox-es</h3>

<ul>
  <li>There must not be two WebBox-es in the same web application 
  with the same <strong>ID</strong>.</li>

  <li>All the files of a WebBox (<strong>.js</strong>,
  <strong>.css</strong>, <strong>.db</strong>, etc.) must have the
  same name as the <strong>ID</strong> of the WebBox, otherwise the
  framework will not reckognize them as belonging to this WebBox.</li>

  <li>You can place more than one WebBox in a template file, however
  it is recomended to place each WebBox in a separate template,
  without other HTML code that does not belong to it. It is recomended
  to name this template <strong>box_id.html</strong>.</li>

  <li>It is recomended to place all the files related to a WebBox in a
  separate folder, for better readability and structure of the
  application.</li>

  <li>Never print anything from the PHP code, except maybe for
  debug!</li>

  <li>Never construct HTML code in the PHP, put all the HTML in the
  template instead!</li>
</ul>

<span class="button"><a href="#toc">TOC</a></span>
<hr />

<a name="study"></a>

<h3>Study the sample application</h3>

<p>Here we will highlight and discuss some of the features of the
sample application, so that we can understand it better.</p>

<ul>
  <li>The <em>menu</em> of pages now is implemented as a WebBox.
  <a href="{{SAPPS_URL}}app3/browse.php?templates/menu/" target="_blank">
  Have a look at its files</a>. Notice that 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/templates/menu/menu.html')">
  <em>menu.html</em></a> does not include explicitly the JS and CSS code 
  of the <em>menu</em> (like templates) because it is done automatically
  by the framework.
  <br /><br />
  </li>

  <li>Notice how are included several webboxes in 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/templates/page2.html','25,28,31,34')">
  <em>Page 2</em></a>. To include a webbox we simply include the template
  that contains the webbox (it is a template inclusion).
  <br /><br />
  </li>

  <li><a href="{{SAPPS_URL}}app3/browse.php?templates/tip/" target="_blank">
  Study</a> the different implementations of the <em>tip</em> webbox
  and notice what is wrong with them (it is explained in the comments).
  (Make sure that you select <em>Code View</em> in the file browser.)
  <br /><br />
  </li>

  <li>The application has defined a constant TIP_PATH in
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/config/const.Paths.php','10')">
  <em>config/const.Paths.php</em></a> and then has used it in several
  places, like in 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/templates/tip/tip.php','4')">
  <em>tip.php</em></a>,
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/templates/tip/fun.get_random_tip.php','11')">
  <em>fun.get_random_tip.php</em></a>, etc.
  This is better than hardcoding paths, because in case that you move 
  or rename this folder, you have to change just the value of a constant 
  and not every occurrence of the path.
  <br /><br />
  </li>

  <li>The framework outputs a wellcome message each time that you initiate
  the application. This is done using the function 
  <strong>WebApp::message()</strong> in the file
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/init.php','9')">
  <em>init.php</em></a>.
  <br /><br />
  </li>

  <li>
  The application has also support for counting clicks and displaying 
  them, however it is optional. See how it is done: 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/config/const.Options.php','72-76')">
  <em>config/const.Options.php</em></a>,
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/init.php','11-14')">
  <em>init.php</em></a>,
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/global.php','10-16')">
  <em>global.php</em></a>. 
  
  <ul>
    <li>The constant COUNT_CLICKS is not a framework constant, 
    it is defined and used by the application.</li>

    <li>The functions <strong>WebApp::addSVar()</strong>, 
    <strong>WebApp::getSVar()</strong>,
    <strong>WebApp::setSVar()</strong> are used to handle 
    <strong>state variables</strong> (or session variables, 
    or persistent variables). We will see more about state variables 
    later.</li>

    <li>
      The files 
      <a href="javascript:codeReview('{{SAPPS_PATH}}app3/init.php')">
      <em>init.php</em></a>,
      <a href="javascript:codeReview('{{SAPPS_PATH}}app3/global.php')">
      <em>global.php</em></a>, as well as
      <a href="javascript:codeReview('{{SAPPS_PATH}}app3/before_page.php')">
      <em>before_page.php</em></a> and
      <a href="javascript:codeReview('{{SAPPS_PATH}}app3/after_page.php')">
      <em>after_page.php</em></a> are optional.

      <dl>
        <dt><strong>init.php</strong></dt>
        <dd>This file is included by the framework only the first time that
        the application is openned (at the beginning of the session).It may
        be used to initialize any thing.</dd>

        <dt><strong>global.php</strong></dt>
        <dd>This file is included every time, if it exists. It may contain
        functions, constants and variables that are used throughout the
        whole application.  </dd>

        <dt><strong>before_page.php</strong></dt>
        <dd>This file is included before each page is parsed.</dd>

        <dt><strong>after_page.php</strong></dt>
        <dd>This file is included after each page is constructed.</dd>
      </dl>
      <br />
      Browse also the 
      <a href="{{SAPPS_URL}}browse.php" target="_blank">empty-sample</a>
      application.
    </li>
  </ul>
  </li>
</ul>

<span class="button"><a href="#toc">TOC</a></span>
<hr />

<a name="exercises"></a>

<h3>Exercises</h3>

<p>Before starting the exercises, make a copy of the application
<em>app2</em> to the folder <em>test/app2</em> and a copy of 
<em>app3</em> to the folder <em>test/app3</em>. If you have problems
with doing this then see the
<a href="javascript:tabs3_select('tabs3::tutorial','transitions')">
first tutorial</a>, second exercise.</p>

<a name="exercise_1"></a>

<h4>1 - Use webbox <em>menu</em> in application <em>app2</em></h4>

<ol>
  <li><kbd>$ cd test/app2/templates</kbd></li>

  <li>Open the file 
  <a href="javascript:codeReview('{{APP2_PATH}}templates/header.html')">
  header.html</a> and append the line: <br />
  <kbd>&amp;lt;include src="{{#UP_PATH}}app3/templates/menu/menu.html" /&amp;gt;</kbd>
  </li>

  <li>Refresh the application <em>app2</em> in browser.</li>
</ol>

<p><strong>UP_PATH</strong> contains the path of the parent folder of the
application.</p>

<p>If you view the HTML code of <em>app2</em> (in browser), you will
notice that <em>menu.js</em> and <em>menu.css</em> have been included
as well in the <em>&amp;lt;head&amp;gt;</em> of the page.</p>


<a name="exercise_2"></a>

<h4>2 - Use webbox <em>tip</em> in application <em>app2</em></h4>

<ol>
  <li><kbd>$ cd test/app2/templates</kbd></li>

  <li>Open the file 
  <a href="javascript:codeReview('{{APP2_PATH}}templates/header.html')">
  header.html</a> and append the line: <br />
  <kbd>&amp;lt;Include src="{{#UP_PATH}}app3/templates/tip/tip.html" /&amp;gt;</kbd>
  </li>

  <li>Refresh the application <em>app2</em> in browser. You will get an
  error, because the <em>TIP_PATH</em> constant is unknown in 
  <em>app2</em>.</li>

  <li>Open
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/templates/tip/tip.php','4')">
  tip.php</a> and replace the include statement with:<br />
  <kbd>$tip_path = dirname(__FILE__)."/";</kbd><br />
  <kbd>include_once $tip_path."fun.get_random_tip.php";</kbd><br />
  Do the same thing with
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/templates/tip/fun.get_random_tip.php','11')">
  fun.get_random_tip.php</a>.</li>

  <li>Refresh the application <em>app2</em> in browser. You will see that
  the tip is displayed, but it has no styles. This is because the framework
  does not reckognize <em>tip_styles.css</em> as being the stylesheet of
  webbox <em>tip</em>. Make a copy of it with the name <em>tip.css</em>:<br />
  <kbd>$ cp tip_styles.css tip.css</kbd></li>

  <li>Refresh again the application. Finally it should be OK.</li>
</ol>

<p><em>__FILE__</em> is a PHP constant and <em>dirname()</em> is a PHP
function.</p>

<a name="exercise_3"></a>
<h4>3 - Enable counting</h4>

<ol>
  <li>Open the file 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/config/const.Options.php','72-76')">
  config/const.Options.php</a> and set the constant 
  <em>COUNT_CLICKS</em> to <em>true</em>.</li>

  <li>Test the application and see what happens. Then make it <em>false</em>
  and test the application again.</li>
</ol>

<p><em>COUNT_CLICKS</em> is not a framework constant, it is defined and 
used by the application <em>app3</em>.</p>

<a name="exercise_4"></a>

<h4>4 - Test <em>before_page.php</em> and <em>after_page.php</em></h4>

<ol>
  <li>Open the files
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/before_page.php','8')">
  before_page.php</a> and
  <a href="javascript:codeReview('{{SAPPS_PATH}}app3/after_page.php','8')">
  after_page.php</a>
  and uncomment the <em>print</em> statements.</li>

  <li>Test the application and see what happens. Then comment them again.</li>
</ol>

<a name="exercise_5"></a>

<h4>5 - Modify the <em>tip</em> webbox</h4>

<ol>
  <li>Suppose that we don't want to display a random tip, but we want to
  display the tips in their order. So, when we first open the app we
  should see the first tip, and each time that we open another page
  we should see the next tip. When we are at the end of the tips we should
  start again from the beginning. Can you do it yourself? You can use
  state variables and the functions <strong>WebApp::addSVar()</strong>,
  <strong>WebApp::setSVar()</strong> and <strong>WebApp::getSVar()</strong>.
  <br /><br />
  </li>

  <li>Now suppose that we want to control ourselves the rotation of the tips.
  That is, the tip will stay the same when we switch the pages, however it
  will have some buttons like this: '<strong>&amp;lt;</strong>'(previous),
  '<strong>&amp;gt;</strong>'(next), '<strong>&amp;lt;&amp;lt;</strong>'(first),
  '<strong>&amp;gt;&amp;gt;</strong>'(last). When we click the button <em>next</em>
  we should get the next tip, etc. How can we do this? Think about it.</li>
</ol>
